%global momorel 1
Summary: A helper application which loads modules for USB devices.
Name: hotplug
Version: 2004_09_23
Release: %{momorel}m
Group: System Environment/Kernel
License: GPL
URL: http://linux-hotplug.sourceforge.net/
# This is incompatible with any current code
Obsoletes: hotplug-gtk
Source0: http://www.kernel.org/pub/linux/utils/kernel/hotplug/%{name}-%{version}.tar.bz2
Source4: http://www.kernel.org/pub/linux/utils/kernel/hotplug/fxload-2002_04_11.tar.bz2
Source5: dasd-devfs-compat-0.2.tar.bz2

%ifnarch s390 s390x
%define with_fxload	1
%define with_dasd_devfs	0
Requires: usbutils >= 0.9

%else
%define with_fxload	0
%define with_dasd_devfs	1
%endif

# We don't want hotplug to initialize the USB core modules, but we
# want to synthesize boot events
Patch0: hotplug-2001_04_24-nousbinit.patch

# Add some IDs
Patch1: hotplug-id.patch

# Call ifdown on interface unregister
Patch2: hotplug-ifdown.patch

# We don't include initscript, don't reference it in the man page
Patch5: hotplug-2003_08_05-initfile.patch


# load sg modules for appropriate devices
Patch7: hotplug-sg.patch

# fix remove events for usb (#121511)
Patch8: hotplug-usb-remove.patch

# Support for osst (#143655)
Patch9: osst-hp.patch

# make sure we bring up the right network interface name
Patch11: hotplug-2002_04_01-hwaddr.patch
Patch12: hotplug-2004_04_01-optim.patch

BuildRoot: %{_tmppath}/%{name}-%{version}-root
Prereq:	chkconfig
Requires: hwdata >= 0.140-1

%description 
The term "hotplugging" refers to the dynamic reconfiguration performed
after a device has been attached to a running system. This package
contains the application which is called by the kernel when a USB
device is added; hotplug then loads the required modules for that
device.

%prep
%setup -q -a 4 -a 5

%patch0 -p1
%patch1 -p1
%patch2 -p1
%patch5 -p1
%patch7 -p1
%patch8 -p1
%patch9 -p1
%patch11 -p1
%patch12 -p1

rm -f etc/hotplug/*.orig

%build 
%if %{with_fxload}
pushd fxload-2002_04_11
make
popd
%endif

%install
# build directories
rm -rf %{buildroot}
make prefix=%{buildroot} install


%if %{with_fxload}
# firmware load utility
pushd fxload-2002_04_11
install -m 755 fxload %{buildroot}/sbin
install -m 644 fxload.8 %{buildroot}/%{_mandir}/man8/
mv README.txt ../README.txt.fxload
popd
%endif

%if %{with_dasd_devfs}
pushd dasd-devfs-compat-0.2
# install the main hotplug script
install -m 755 sbin/* %{buildroot}/sbin/

# install the helper hotplug scripts
cp -a -r etc/hotplug/* %{buildroot}/etc/hotplug/
popd
%endif

mkdir -m 755 -p %{buildroot}/lib/firmware

# We don't use this
rm -f %{buildroot}%{_initscriptdir}/hotplug

# Put this in hwdata
rm -f %{buildroot}/etc/hotplug/blacklist

%clean
rm -fr %{buildroot}

%files
%defattr(-,root,root)
%doc README ChangeLog
%if %{with_fxload}
  %doc README.txt.fxload
%endif
/lib/firmware
/sbin/*
%config %{_sysconfdir}/hotplug/*
%dir %{_sysconfdir}/hotplug
%dir %{_sysconfdir}/hotplug.d
%config %{_sysconfdir}/hotplug.d/*
%config(noreplace)  %{_sysconfdir}/hotplug/usb.usermap 
%dir /var/run/usb
%{_mandir}/*/*

%changelog
* Sat Mar  5 2005 TABUCHI Takaaki <tab@momonga-linux.org>
- (2004_09_23-1m)
- version update to 2004_09_23

* Sat Feb  5 2005 Toru Hoshina <t@momonga-linux.org>
- (2004_04_01-1m)
- version update to 2004_04_01

* Thu Sep  2 2004 Shigeru Yamazaki <muradaikan@momonga-linux.org>
- (2004_03_29-1m)
- version update to 2004_03_29
- remove Patches 3, 4, 6, 7, 8, 9, 10

* Tue Jun 17 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (2003_05_01-2m)
  sorry, forgot to include /etc/hotplug.d

* Tue Jun  3 2003 Tsutomu Yasuda <tom@tom.homelinux.org>
- (2003_05_01-1m)
  update to 2003_05_01

* Fri Apr 11 2003 Shingo Akagaki <dora@kitty.dnsalias.org>
- (2002_08_26-2m)
- apply changes from rawhide rpm. (2002_04_1-17)
  important changes:
   remove wireless patch, should be handled all by ifup.
   remove the initscript.

* Sat Sep 21 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (2002_08_26-1m)
- update to 2002_08_26
- fix %%files

* Tue Jul 16 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (2002_04_02-6m)
- fix comment typo in ieee1394.agent

* Tue Jul 16 2002 YAMAZAKI Makoto <uomaster@nifty.com>
- (2002_04_02-5m)
- fix pcmcia network card register problem (redirect some outputs to /dev/null)

* Mon Jun  3 2002 Kazuhiko <kazuhiko@kondara.org>
- (2002_04_02-4k)
- add an init script
- remove /etc/hotplug/*~

* Wed May  8 2002 Toru Hoshina <t@kondara.org>
- (2002_04_01-2k)
- Import from RHL Rawhide

* Thu Apr 11 2002 Trond Eivind Glomsr?<teg@redhat.com> 2002_04_01-3
- Make it insert the joydev module for Gravis Gamepad and Saitek 
  Cyborg 3D USB (#63148)

* Fri Apr  5 2002 Trond Eivind Glomsr?<teg@redhat.com> 2002_04_01-2
- Remove the build root after build (#62790)

* Mon Apr  1 2002 Trond Eivind Glomsr?<teg@redhat.com> 2002_04_01-1
- 2002_04_01

* Thu Feb 21 2002 Trond Eivind Glomsr?<teg@redhat.com> 2002_01_14-2
- Rebuild

* Mon Jan 14 2002 Trond Eivind Glomsr?<teg@redhat.com> 2002_01_14-1
- 2002_01_14
- usbutils is now a separate package. Require it.

* Tue Nov  6 2001 Trond Eivind Glomsr?<teg@redhat.com> 2001_09_19-1
- 2001_09_19

* Tue Nov  6 2001 Trond Eivind Glomsr?<teg@redhat.com> 2001_04_24-13
- Add /etc/hotplug/usb directory (#55775)

* Tue Sep 18 2001 Trond Eivind Glomsr?<teg@redhat.com> 2001_04_24-12
- Add patch from mlord@pobox.com to use gt, not ge for one of the comparions
  in the usb.agent script(#53435). We use usbmodules for this now, so the
  patch isn't in the path of execution.

* Mon Aug 27 2001 Trond Eivind Glomsr?<teg@redhat.com> 2001_04_24-11
- Install usbmodules from usbutils to help sove various 
  module insertion problems (#52630, #52100, #51229, #52546)

* Sun Aug 19 2001 Bill Nottingham <notting@redhat.com>
- revert last change. I was on crack.

* Wed Aug  8 2001 Bill Nottingham <notting@redhat.com>
- handle network unregistration events too

* Mon Aug  6 2001 Trond Eivind Glomsr?<teg@redhat.com>
- Add extra identifiers for Wacom tablets (#50454)
- Define IN_HOTPLUG before invoking ifup (part of #47483)

* Mon Jul 16 2001 Bill Nottingham <notting@redhat.com>
- own /etc/hotplug
- what dunderhead put that broken code in the wireless stuff? Oh yeah, me.
  (#49021)

* Tue Jul 10 2001 Trond Eivind Glomsr?<teg@redhat.com>
- Add defattr to gtk subpackage
- make the lines in the description shorter

* Sun Jul  8 2001 Bill Nottingham <notting@redhat.com>
- fix namespace collision with initscripts in net.agent (HWADDR),
  use ip, not ifconfig

* Tue Jun 19 2001 Florian La Roche <Florian.LaRoche@redhat.de>
- Preston is right, ExcludeArch is better

* Tue Jun 19 2001 Arjan van de Ven <arjanv@redhat.com>
- Added hotplug PCI support

* Wed Jun 13 2001 Trond Eivind Glomsr?<teg@redhat.com>
- Change for wireless as suggested in #44381

* Mon May 21 2001 Trond Eivind Glomsr?<teg@redhat.com>
- 2001-04-24 packages
- redo all patches, drop some, consolidate others
- Include new man page

* Sun Apr 01 2001 Erik Troan <ewt@redhat.com>
- devices wouldn't match the upper limit of device id ranges

* Thu Mar 29 2001 Trond Eivind Glomsr?<teg@redhat.com>
- Make it sleep (20 intervals of 30 seconds) if /tmp is ro
  instead of exiting. This should make "hotplugging"
  of devices present at boot time work.

* Tue Mar 20 2001 Trond Eivind Glomsr?<teg@redhat.com>
- run updfstab on remove events
- remove the initscript, usbdevfs is now initialized before the controller

* Fri Mar  2 2001 Trond Eivind Glomsr?<teg@redhat.com>
- don't ifup interfaces when the network is stopped
  (#22978)

* Fri Mar  2 2001 Bill Nottingham <notting@redhat.com>
- move wireless invocations to the right place

* Thu Mar  1 2001 Trond Eivind Glomsr?<teg@redhat.com>
- Run updfstab when adding usb-storage devices

* Thu Mar  1 2001 Bill Nottingham <notting@redhat.com>
- don't ship backup files

* Wed Feb 28 2001 Bill Nottingham <notting@redhat.com>
- ignore cipe, plip, and loopback devices as well

* Wed Feb 28 2001 Nalin Dahyabhai <nalin@redhat.com>
- fire off netreport updates when interfaces get registered/deregistered

* Tue Feb 27 2001 Bill Nottingham <notting@redhat.com>
- invoke the pcmcia wireless script for wireless devices

* Thu Feb 22 2001 Trond Eivind Glomsr?<teg@redhat.com>
- add pci hotplug scripts (those weren't the ones bringing machines down)
- activate the script
- change initscript so it never tries to load usb controller modules, just synthesize events

* Fri Feb 16 2001 Trond Eivind Glomsr?<teg@redhat.com>
- Fix ppp/isdn issue (interface up/down/up/down...)

* Thu Feb 15 2001 Trond Eivind Glomsr?<teg@redhat.com>
- remove init script - it makes some of the Dell servers hang.
- remove chkconfig in post, preun
- only include the usb files in /etc/hotplug - PCI hotplug
  doesn't work 

* Wed Feb 14 2001 Trond Eivind Glomsr?<teg@redhat.com>
- Make summary and description match our old package
- sanitize initscript, so it matches the others
- Add Epoch, so we can upgrade older RPMs with Epoch: 2

* Wed Feb 14 2001 Greg Kroah-Hartman <greg@kroah.com>
- 2001_02_14 release

* Wed Jan 17 2001 Greg Kroah-Hartman <greg@kroah.com>
- changed specfile based on Chmouel Boudjnah's <chmouel@mandrakesoft.com> comments.

* Tue Jan 16 2001 Greg Kroah-Hartman <greg@kroah.com>
- tweaked the file locations due to the change in the tarball structure.
- 2001_01_16 release

* Mon Jan 15 2001 Greg Kroah-Hartman <greg@kroah.com>
- First cut at a spec file for the hotplug scripts.
- added patch to usb.rc to allow chkconfig to install and remove it.

